-- BEGIN SCRIPT --
CREATE OR REPLACE FORCE VIEW V_APPROVE_LOT
(OBJECT_TRANS_ID, FUND_PAYMENT_APPROVE_LOT_ID, APPROVE_TRAN_TYPE, FLOWPAYMENTMNG_STATUS)
BEQUEATH DEFINER
AS 
SELECT OBJECT_TRANS_ID, V.FUND_PAYMENT_APPROVE_LOT_ID, V.APPROVE_TRAN_TYPE, F.FLOWPAYMENTMNG_STATUS
  FROM FUND_PAYMENT_APPROVE_LOT F
       INNER JOIN VERIFY_APPROVE_LOT V ON F.FUND_PAYMENT_APPROVE_LOT_ID = V.FUND_PAYMENT_APPROVE_LOT_ID
       INNER JOIN VERIFY_LOT_MAP_PAYMENT LM
          ON V.VERIFY_APPROVE_LOT_ID = LM.VERIFY_APPROVE_LOT_ID
       INNER JOIN MATCH_TRANS_PAYMENT M
          ON LM.MATCH_TRANS_ID = M.MATCH_TRANS_ID
       WHERE F.FLOWPAYMENTMNG_STATUS != 'R';

CREATE OR REPLACE FORCE VIEW V_FUND_ACCOUNT_BANK
(FUND_ID, ACC_NO, BANK_ID, BRANCH_ID, ACC_WORK, 
 IS_HAVE_STATEMENT, IS_DEFAULT_INSTRUCTION, BANK_NAME, BRANCH_NAME)
BEQUEATH DEFINER
AS 
SELECT
    faa.fund_id,
    faa.acc_no,
    faa.bank_id,
    faa.branch_id,
    faa.acc_work,
    faa.is_have_statement,
    faa.is_default_instruction,
    bk.bank_name,
    br.branch_name
FROM
    fund fa,
    fund_account faa,
    bank bk,
    branch br
WHERE
    fa.fund_id = faa.fund_id
    AND bk.bank_id = br.bank_id
    AND faa.bank_id = bk.bank_id
    AND br.branch_id = faa.branch_id;

COMMENT ON TABLE V_FUND_ACCOUNT_BANK IS 'ข้อมูลธนาคารของบัญชีแต่ละกองทุน';


CREATE OR REPLACE FORCE VIEW V_LIST_TRANSACTION_FEE
(TRANS_FEE_HEADER_ID, FUND_TYPE_ID, FUND_TYPE_NAME, FUND_ID, FUND_CODE, 
 FUND_NAME, NAV_DATE, TRANS_FEE_DETIAL_COUNT, AMOUNT, TRANSACTION_FEE, 
 TRANS_FEE_STATUS, REJECT_STEP, DELETE_STEP, NOTE, PAYEE_NAME, 
 TBL_ID_PAYTYPE, BANK_ID, ACC_NO, PAYMENT_DATE, USER_ID, 
 UPDATE_DATETIME, APPROVE_M_USER_ID, APPROVE_M_UPDATE_DATETIME)
BEQUEATH DEFINER
AS 
SELECT
    TF.Trans_Fee_Header_id,
    F.TBL_ID_FUNDTYPE AS FUND_TYPE_ID,
    TL.TBL_DESC AS FUND_TYPE_NAME,
    TF.FUND_ID,
    F.FUND_CODE,
    F.NAME_THAI AS FUND_NAME,
    TF.NAV_DATE,
    (SELECT COUNT(trans_fee_detail_id) FROM TRANS_FEE_DETAIL TFD WHERE TFD.Trans_Fee_Header_id = TF.Trans_Fee_Header_id) AS TRANS_FEE_DETIAL_COUNT,
    TF.AMOUNT,
    TF.TRANSACTION_FEE,
    TF.Trans_Fee_STATUS,
    TF.REJECT_STEP,
    TF.DELETE_STEP,
    TF.NOTE,
    TF.PAYEE_NAME,
    TF.TBL_ID_PAYTYPE,
    TF.BANK_ID,
    TF.ACC_NO,
    TF.PAYMENT_DATE,
    TF.USER_ID,
    TF.update_datetime,
    TF.APPROVE_M_USER_ID,
    TF.APPROVE_M_UPDATE_DATETIME
  FROM Trans_Fee_Header TF
  INNER JOIN FUND F ON F.FUND_ID = TF.FUND_ID
  INNER JOIN TABLE_LINE TL ON TL.TBL_CODE = 'FundType' AND TL.TBL_ID = F.TBL_ID_FUNDTYPE;

CREATE OR REPLACE FORCE VIEW V_OVERCON_PAYMENT_TYPE
(PAYMENT_ID, PAYMENT_NAME, PAYMENT_GROUP, PAYMENT_GROUP_NAME)
BEQUEATH DEFINER
AS 
WITH paytype
        AS (SELECT et.tbl_id Payment_id,
                   et.tbl_desc Payment_name,
                   et.tbl_value Payment_Group_id
              FROM TABLE_LINE et
             WHERE tbl_code = 'Payment'),
        paymentgrp
        AS (SELECT et1.tbl_id Payment_Group_id,
                   et1.tbl_desc Payment_Group_name
              FROM TABLE_LINE et1
             WHERE tbl_code = 'Payment_Group'),
        overpaymentgrp
        AS (SELECT et1.tbl_id Payment_Group_id,
                   et1.tbl_desc Payment_Group_name
              FROM TABLE_LINE et1
             WHERE tbl_code = 'OverCon_Payment_Group')
   SELECT paytype.PAYMENT_ID,
          paytype.PAYMENT_NAME,
          paymentgrp.Payment_Group_id PAYMENT_GROUP,
          paymentgrp.Payment_Group_name
     FROM paytype, paymentgrp, overpaymentgrp
    WHERE paytype.Payment_Group_id = paymentgrp.Payment_Group_id
    and overpaymentgrp.Payment_Group_id = paytype.Payment_Group_id order by paymentgrp.Payment_Group_id;

CREATE OR REPLACE FORCE VIEW V_OVERCON_STATUS
(OVERCON_STATUS_ID, OVERCON_STATUS_VALUE, OVERCON_STATUS)
BEQUEATH DEFINER
AS 
SELECT et.tbl_id OVERCON_STATUS_ID, et.TBL_VALUE OVERCON_STATUS_VALUE, et.tbl_desc OVERCON_STATUS
     FROM TABLE_LINE et
    WHERE tbl_code = 'OVERCON_STATUS';

CREATE OR REPLACE FORCE VIEW V_PAY_TO
(TBL_ID, TBL_DESC)
BEQUEATH DEFINER
AS 
select  tbl_ID,tbl_desc from TABLE_LINE
where TBL_CODE = 'PAY_TO';

CREATE OR REPLACE FORCE VIEW V_STATEMENT_DESC
(STM_ID, STM_HD_ID, REC_TYPE, ACC_NO, BANK_ID, 
 BRANCH_ID, OPN_TRN_CLS_DATE, OPN_TRN_CLS_BALANCE, OPN_TRN_CLS_SIGN, ACC_NAME, 
 TRAN_AMT, TRAN_CODE, DR_CR_MARK, TERMINAL_NUMBER, CHQ_NO, 
 REF_NO, EFFECTIVE_DATE, NEW_CHQ_NO, AVALIABLE_BALANCE, AVALIABLE_BALANCE_SIGN, 
 TOTAL_ITEM, STM_STATUS, USER_ID, UPDATE_DATETIME, OPN_TRAN_CLS_BALANCE, 
 OPN_TRAN_CLS_SIGN, REMAIN_BALANCE, IMPORT_DATE)
BEQUEATH DEFINER
AS 
SELECT D."STM_ID",D."STM_HD_ID",D."REC_TYPE",D."ACC_NO",D."BANK_ID",D."BRANCH_ID",D."OPN_TRN_CLS_DATE",D."OPN_TRN_CLS_BALANCE",D."OPN_TRN_CLS_SIGN",D."ACC_NAME",D."TRAN_AMT",D."TRAN_CODE",D."DR_CR_MARK",D."TERMINAL_NUMBER",D."CHQ_NO",D."REF_NO",D."EFFECTIVE_DATE",D."NEW_CHQ_NO",D."AVALIABLE_BALANCE",D."AVALIABLE_BALANCE_SIGN",D."TOTAL_ITEM",D."STM_STATUS",D."USER_ID",D."UPDATE_DATETIME",D."OPN_TRAN_CLS_BALANCE",D."OPN_TRAN_CLS_SIGN",D."REMAIN_BALANCE" ,H.IMPORT_DATE 
FROM STATEMENT_DESC D, STATEMENT_HD H
where D.STM_HD_ID = H.STM_HD_ID;

CREATE OR REPLACE FORCE VIEW V_STEP1_TRANSACTION_FEE
(FUND_ID, FUND_CODE, FUND_TYPE_ID, FUND_TYPE_NAME, EMPYEE_ID, 
 EMPYEE_CODE, EMPYEE_TITLE_NAME, EMPYER_NO, EMPYER_NAME, NAV_DATE, 
 EMPYEE_FEE_AMOUNT)
BEQUEATH DEFINER
AS 
SELECT
dp.FUND_ID,
MIN(F.FUND_CODE) AS FUND_CODE,
MIN(F.TBL_ID_FUNDTYPE) AS FUND_TYPE_ID,
MIN(TL.TBL_DESC) AS FUND_TYPE_NAME,
dp.EMPYEE_ID,
MIN(E.EMPYEE_CODE) AS EMPYEE_CODE,
MIN(TLE.TBL_DESC || e.empyee_name || ' ' || e.empyee_surname) AS EMPYEE_TITLE_NAME,
MIN(c.empyer_no) AS EMPYER_NO,
MIN(c.empname_thai) AS EMPYER_NAME,
dp.NAV_DATE,
SUM(dp.REC_AMOUNT_INIT) AS EMPYEE_FEE_AMOUNT
FROM Desc_Pay_Claim dp
INNER JOIN INSTALLMENT_TRANSACTION it ON it.INSTALL_TRAN_ID = dp.TRAN_MAIN_ID
INNER JOIN FUND F ON F.FUND_ID = dp.FUND_ID
INNER JOIN TABLE_LINE TL ON TL.TBL_CODE = 'FundType' AND TL.TBL_ID = F.TBL_ID_FUNDTYPE
INNER JOIN EMPLOYEE E ON E.EMPYEE_ID = dp.EMPYEE_ID
INNER JOIN TABLE_LINE TLE ON TLE.TBL_ID = e.empyee_tbl_id_titlename
INNER JOIN EMPLOYER C ON C.EMPYER_ID = E.EMPYER_ID
WHERE dp.JOB_ALL_ID = 'EYP' AND it.period_no > 0
GROUP BY dp.FUND_ID,dp.EMPYEE_ID,dp.NAV_DATE;

CREATE OR REPLACE FORCE VIEW V_STEP2_TRANSACTION_FEE_EMPYEE
(TRANS_FEE_HEADER_ID, FUND_ID, NAV_DATE, EMPYER_ID, EMPYEE_ID, 
 EMPYEE_CODE, EMPYEE_NAME, EMPYEE_FEE_AMOUNT)
BEQUEATH DEFINER
AS 
SELECT
tf.trans_fee_header_id,
tf.FUND_ID,
tf.NAV_DATE,
e.EMPYER_ID,
dp.EMPYEE_ID,
MIN(e.empyee_code) AS EMPYEE_CODE,
MIN(TLE.TBL_DESC || e.empyee_name || ' ' || e.empyee_surname) AS EMPYEE_NAME,
SUM(dp.REC_AMOUNT_INIT) AS EMPYEE_FEE_AMOUNT
FROM TRANS_FEE_DETAIL tfd
INNER JOIN trans_fee_header tf ON tf.trans_fee_header_id = tfd.trans_fee_header_id
INNER JOIN desc_pay_claim dp ON dp.desc_pay_claim_id = tfd.desc_pay_claim_id
INNER JOIN EMPLOYEE e ON E.EMPYEE_ID = dp.EMPYEE_ID
INNER JOIN TABLE_LINE TLE ON TLE.TBL_ID = e.empyee_tbl_id_titlename
GROUP BY tf.trans_fee_header_id,tf.FUND_ID,tf.NAV_DATE,e.EMPYER_ID,dp.EMPYEE_ID;

CREATE OR REPLACE FORCE VIEW V_STEP2_TRANSACTION_FEE_EMPYER
(TRANS_FEE_HEADER_ID, FUND_ID, NAV_DATE, EMPYER_ID, COUNT_EMPYEE, 
 EMPYER_NAME, TRANSACTION_FEE)
BEQUEATH DEFINER
AS 
SELECT
tf.trans_fee_header_id,
tf.FUND_ID,
tf.NAV_DATE,
e.EMPYER_ID,
(SELECT COUNT(*) FROM V_STEP2_TRANSACTION_FEE_EMPYEE WHERE trans_fee_header_id = tf.trans_fee_header_id) AS COUNT_EMPYEE,
MIN(c.empname_thai) AS EMPYER_NAME,
COUNT(E.EMPYEE_ID) * MIN(NVL(tf.transaction_fee,0)) AS TRANSACTION_FEE
FROM TRANS_FEE_DETAIL tfd
INNER JOIN trans_fee_header tf ON tf.trans_fee_header_id = tfd.trans_fee_header_id
INNER JOIN desc_pay_claim dp ON dp.desc_pay_claim_id = tfd.desc_pay_claim_id
INNER JOIN EMPLOYEE e ON E.EMPYEE_ID = dp.EMPYEE_ID
INNER JOIN TABLE_LINE TLE ON TLE.TBL_ID = e.empyee_tbl_id_titlename
INNER JOIN EMPLOYER C ON C.EMPYER_ID = E.EMPYER_ID
GROUP BY tf.trans_fee_header_id,tf.FUND_ID,tf.NAV_DATE,e.EMPYER_ID;

CREATE OR REPLACE FORCE VIEW V_SUB_FUND
(MASTER_FUND_ID, FUND_ID, FUND_CODE, NAME_THAI_PREFIX, NAME_THAI, 
 NAME_THAI_SUFFIX, NAME_ENG, EFFECTIVE_DATE, CONTRACT_YEAR, CONTRACT_MONTH, 
 CONTRACT_END_DATE, TBL_ID_EXTEND_CNTRC, TBL_ID_REGTYPE, TBL_ID_FUNDTYPE, ISMASTER, 
 FUND_NAME_TRANSFER_FROM, REGISTRA_NAME_TRANSFER_FROM, CUSTODIAN_FEE, CUSTODIAN_TYPEFEE, CUSTODIAN_TYPEVAT, 
 NAV_FEE, NAV_TYPEFEE, NAV_TYPEVAT, BANK_ID, TBL_ID_AMC_PORT_TYPE, 
 PURPOSE_INVEST, BENCHMARK_ID, MNGFEE_TEXT, IS_SHORTTERM, IS_FIXINCOME, 
 ASSETCLS_OTH, ASSETCLS_EQ, ASSETCLS_AI, SUIT_LEVEL, REG_NO, 
 REG_DATE, TAX_ID, ADDRESS_CODE, FUND_STATUS, REMARK_ID, 
 USER_ID, UPDATE_DATETIME, MKT_INVESTMENT_POLICY, USER_ID_CREATE, UPDATE_DATETIME_CREATE, 
 USER_ID_APPROVE, UPDATE_DATETIME_APPROVE, DERIVATIVES, NAME_ENG_SUFFIX, ISKNOWEFFECTIVE, 
 CONTRACT_DAY, ISSHIFT_EFT, ISKNOWEFFECTIVE_BF_SHIFT, EFFECTIVE_DATE_BF_SHIFT, TBL_ID_SHIFT_EFT, 
 USER_ID_SHIFT, UPDATE_DATETIME_SHIFT, ISNAV_TRANSFER, PRIVILEGE_APPROVE_CIP, USER_ID_HEADAPPROVE, 
 UPDATE_DATETIME_HEADAPPROVE, SETTLE_DAYS_SW_INMASTER, SETTLE_DAYS_SW_OUTMASTER, SETTLE_DAYS_CLM, INACTIVE_DATE, 
 SW_FORMULA, UNVESTED_FORMULA, PAY_TAX_DAYS, SETTLE_DAYS_OTHER, ISSENDTAX, 
 OR_LOSS_TYPE, ISREGISTRA, RISK_LEVEL)
BEQUEATH DEFINER
AS 
SELECT DECODE (MASTER_FUND_ID, 0, FUND_ID, MASTER_FUND_ID)
               AS MASTER_FUND_ID,
            FUND_ID,
            FUND_CODE,
            NAME_THAI_PREFIX,
            NAME_THAI,
            NAME_THAI_SUFFIX,
            NAME_ENG,
            EFFECTIVE_DATE,
            CONTRACT_YEAR,
            CONTRACT_MONTH,
            CONTRACT_END_DATE,
            TBL_ID_EXTEND_CNTRC,
            TBL_ID_REGTYPE,
            TBL_ID_FUNDTYPE,
            ISMASTER,
            FUND_NAME_TRANSFER_FROM,
            REGISTRA_NAME_TRANSFER_FROM,
            CUSTODIAN_FEE,
            CUSTODIAN_TYPEFEE,
            CUSTODIAN_TYPEVAT,
            NAV_FEE,
            NAV_TYPEFEE,
            NAV_TYPEVAT,
            BANK_ID,
            TBL_ID_AMC_PORT_TYPE,
            PURPOSE_INVEST,
            BENCHMARK_ID,
            MNGFEE_TEXT,
            IS_SHORTTERM,
            IS_FIXINCOME,
            ASSETCLS_OTH,
            ASSETCLS_EQ,
            ASSETCLS_AI,
            SUIT_LEVEL,
            REG_NO,
            REG_DATE,
            TAX_ID,
            ADDRESS_CODE,
            FUND_STATUS,
            REMARK_ID,
            USER_ID,
            UPDATE_DATETIME,
            MKT_INVESTMENT_POLICY,
            USER_ID_CREATE,
            UPDATE_DATETIME_CREATE,
            USER_ID_APPROVE,
            UPDATE_DATETIME_APPROVE,
            DERIVATIVES,
            NAME_ENG_SUFFIX,
            ISKNOWEFFECTIVE,
            CONTRACT_DAY,
            ISSHIFT_EFT,
            ISKNOWEFFECTIVE_BF_SHIFT,
            EFFECTIVE_DATE_BF_SHIFT,
            TBL_ID_SHIFT_EFT,
            USER_ID_SHIFT,
            UPDATE_DATETIME_SHIFT,
            ISNAV_TRANSFER,
            PRIVILEGE_APPROVE_CIP,
            USER_ID_HEADAPPROVE,
            UPDATE_DATETIME_HEADAPPROVE,
            SETTLE_DAYS_SW_INMASTER,
            SETTLE_DAYS_SW_OUTMASTER,
            SETTLE_DAYS_CLM,
            INACTIVE_DATE,
            SW_FORMULA,
            UNVESTED_FORMULA,
            PAY_TAX_DAYS,
            SETTLE_DAYS_OTHER,
            ISSENDTAX,
            OR_LOSS_TYPE,
            ISREGISTRA,
            RISK_LEVEL
       FROM FUND;

CREATE OR REPLACE FORCE VIEW V_TRANS_REIMBURSE_DOCUMENT
(TRANS_REIMBURSE_DOCUMENT_ID, TRANS_REIMBURSE_ID, TBL_ID_DOCLIST, HAVE_DOC, USER_ID, 
 UPDATE_DATETIME, TBL_DOCLIST_DESC)
BEQUEATH DEFINER
AS 
select
    D."TRANS_REIMBURSE_DOCUMENT_ID",D."TRANS_REIMBURSE_ID",D."TBL_ID_DOCLIST",D."HAVE_DOC",D."USER_ID",D."UPDATE_DATETIME",T.TBL_DESC as TBL_DOCLIST_DESC
from TRANS_REIMBURSE_DOCUMENT D ,
     TABLE_LINE  T
where
     D.TBL_ID_DOCLIST = T.TBL_ID
order by T.TBL_SEQ;

CREATE OR REPLACE FORCE VIEW V_UNVESTEDMONEY_GROUP
(UNVESTEDMONEYGROUPDESC, UNVESTEDMONEYGROUPID, UNVESTEDMONEYID, UNVESTEDMONEYDESC)
BEQUEATH DEFINER
AS 
WITH UNVESTEDMONEYGROUP
     AS (SELECT *
           FROM TABLE_LINE ET
          WHERE TBL_CODE = 'UnvestedMoneyGroup'),
     UNVESTEDMONEY
     AS (SELECT *
           FROM TABLE_LINE ET
          WHERE TBL_CODE = 'UnvestedMoney')
SELECT UNVESTEDMONEYGROUP.TBL_DESC AS UNVESTEDMONEYGROUPDESC,
       UNVESTEDMONEYGROUP.TBL_ID UNVESTEDMONEYGROUPID,
       UNVESTEDMONEY.TBL_ID UNVESTEDMONEYID,
       UNVESTEDMONEY.TBL_DESC UNVESTEDMONEYDESC
  FROM UNVESTEDMONEYGROUP, UNVESTEDMONEY
 WHERE UNVESTEDMONEY.TBL_MASTER_ID = UNVESTEDMONEYGROUP.TBL_ID;

CREATE OR REPLACE FORCE VIEW V_USER_FUND_ALL
(USER_ID, FUND_ID)
BEQUEATH DEFINER
AS 
WITH EMGRPD AS (SELECT EMPYER_ID, GRP_EMPYER_ID FROM EMPYER_GROUP_DETAIL),
        DATA_EMPYER
        AS (SELECT EMGRPD.GRP_EMPYER_ID,
                   EM.EMPYER_ID,
                   EM.EMPYER_NO,
                   EM.EMPNAME_THAI,
                   EM.STATUS_EMPYER,
                   EMG.ISACCESS_ALL
              FROM EMPLOYER EM
                   INNER JOIN EMGRPD ON EM.EMPYER_ID = EMGRPD.EMPYER_ID
                   INNER JOIN EMPLOYER_GROUP EMG
                      ON EMG.GRP_EMPYER_ID = EMGRPD.GRP_EMPYER_ID
             WHERE EMG.ISACCESS_ALL = 'N'
            UNION
            SELECT GRP_EMPYER_ID,
                   EM.EMPYER_ID,
                   EM.EMPYER_NO,
                   EM.EMPNAME_THAI,
                   EM.STATUS_EMPYER,
                   ISACCESS_ALL
              FROM EMPLOYER EM, EMPLOYER_GROUP EMG
             WHERE EMG.ISACCESS_ALL = 'Y')
     SELECT DISTINCT L1.USER_ID, F1.FUND_ID
       FROM LOGIN_PROFILE_KA L1
            INNER JOIN DATA_EMPYER E1 ON L1.GRP_EMPYER_ID = E1.GRP_EMPYER_ID
            INNER JOIN EMP_FUND F1 ON E1.EMPYER_ID = F1.EMPYER_ID
            INNER JOIN FUND F2 ON F1.FUND_ID = F2.FUND_ID
   ORDER BY L1.USER_ID, F1.FUND_ID;
   
   EXIT;